<?php
/****************************************************************************************
* Automatisation de l'installation et de la mise à jour de la base de données Wordpress *
****************************************************************************************/

$install->echo_sstitre("Base de données");

//le nécessaire pour utiliser l'API de Wordpress
$install->afficher("Inclusion des scripts... ");
define('WP_INSTALLING', true); //nécessaire sinon redirection automatique si Wordpress non encore installé (voir "wp-settings.php", lignes 277-288)
require_once(ABSPATH.'wp-config.php');
require_once(ABSPATH.'wp-admin/includes/upgrade.php');
if(isset($wp_version)) $install->afficher("version \"".$wp_version."\"... ");
else $install->afficher("version non identifiée... ");
$install->afficher("OK\n");

//variables dont certaines spécifiques pour gérer l'installation des plugins
if(!defined('WP_SITEURL')) define('WP_SITEURL','https://'.WEB_URL.'/wordpress'); //utile ?
if(!defined('WP_PLUGIN_DIR')) define('WP_PLUGIN_DIR',ABSPATH.'wp-content/plugins'); //à priori déjà définie par l'inclusion précédente
define('PLUGIN_CAS','wpcas-conf.php');
define('PLUGIN_WP_SENTRY','wp-sentry/wp-sentry.php');

//$wp_db_version = version des fichiers définie dans "wp-includes/version.php" inclus automatiquement
$wp_current_db_version = get_option('db_version'); //version de la base de données

$test = "SHOW TABLES";
$install->setRows($test,DB_NAME);
if(count($install->rows)===0)
	{
	$install->afficher("Installation des tables... ");
	wp_install(LIBELLE_ETAB, "admin", "ce.".NUMERO_ETAB."@".NOM_ACADEMIE.".fr", true, '');
	$install->afficher("OK\n");
		
	$install->afficher("Options par défaut... ");
	$option_name = "template";
	$newvalue="classic";
	update_option($option_name,$newvalue);
	$option_name = "stylesheet";
	$newvalue="classic";
	update_option($option_name,$newvalue);
	$install->afficher("OK\n");

	$install->afficher("Eviter l'avertissement du mot de passe de l'admin à changer... ");
	$install->setRows("SELECT `umeta_id` FROM `".$table_prefix."usermeta` WHERE `user_id`=1 AND `meta_key`='default_password_nag' AND `meta_value`=1;",DB_NAME);
	if(count($install->rows)>0) $install->query("UPDATE `".$table_prefix."usermeta` SET `meta_value`=0 WHERE `umeta_id`=".$install->rows[0]["umeta_id"].";",DB_NAME);
	$install->afficher("OK\n");
	}
elseif($wp_current_db_version!=$wp_db_version)
	{
	$install->afficher("Mise à jour des tables de la version ".$wp_current_db_version." vers la version ".$wp_db_version."... ");
	wp_upgrade();
	$install->afficher("OK\n");
	
	//spécifique envole 1.5 et donc voué à disparaître
	if(AJAX_PORTAIL)
		{
		$install->afficher("Mise à jour de la version dans Ajax-Portail... ");
		$install->query("UPDATE `".PORTAL_PREFIX."ajaxp_settings` SET value='".$wp_db_version."' WHERE `param`= 'VERSION_".strtoupper(APPLI_MODULE)."';",PORTAL_NAME);
		$install->afficher("OK\n");
		}
	}
else $install->afficher("Aucune mise à jour des tables n'est nécessaire (version actuelle : ".$wp_current_db_version.").\n");

//Opérations systématiques
$install->afficher("Enregistrement des paramètres... ");

$option_name = "blog_charset";
$newvalue = "UTF-8";
update_option($option_name,$newvalue);

$option_name = "siteurl";
$newvalue = "https://".ENVOLE_URL."/wordpress";
update_option($option_name,$newvalue);

$option_name = "home";
$newvalue = "https://".ENVOLE_URL."/wordpress";
update_option($option_name,$newvalue);

$option_name = "upload_path";
$newvalue = "wp-content/uploads";
update_option($option_name,$newvalue);

$install->afficher("OK\n");

//plugin CAS
$install->afficher("Plugin CAS... ");
if(@is_file($install->rep_files.PLUGIN_CAS))
	{
	$install->afficher("copie... ");
	$install->copier($install->rep_files.PLUGIN_CAS, WP_PLUGIN_DIR."/".PLUGIN_CAS);
	
	$install->afficher("activation... ");
	activate_plugin("wpcas.php","");
	
	$install->afficher("OK\n");
	}
else $install->afficher("fichier original \"".$install->rep_files.PLUGIN_CAS."\" introuvable -> copie et activation impossible.\n");

//plugin wp-sentry
$install->afficher("Plugin wp-sentry... ");
$install->afficher("activation... ");
activate_plugin(PLUGIN_WP_SENTRY,"");

//par précaution, on vérifie que la table est bien présente
$install->setRows("SHOW TABLES FROM `".DB_NAME."` LIKE '%sentry_groups'",DB_NAME);
if(count($install->rows)>0)
	{
	$install->afficher("options... ");	
	$option_name = "sentry_preview_all_users_only";
	$newvalue = "Yes";
	update_option($option_name,$newvalue);
	$option_name = "sentry_denied_message";
	$newvalue="<p>Vous n&rsquo;&ecirc;tes pas autoris&eacute; &agrave; lire cet article.</p>";
	update_option($option_name, $newvalue);
	$option_name = "sentry_post_title_prefix";
	$newvalue = "Priv&eacute; : ";
	update_option($option_name,$newvalue);

	$install->afficher("groupes... ");
	//groupes par défaut
	$groupes = array("eleves","responsables","enseignants","personnels-administratifs");
	foreach($groupes as $libelle)
		{
		$install->setRows("SELECT `id` FROM `".$table_prefix."sentry_groups` WHERE `name`='".$libelle."';",DB_NAME);
		if(count($install->rows)===0) $install->query("INSERT INTO `".$table_prefix."sentry_groups` SET `name`='".$libelle."';",DB_NAME);	
		}
	//transfert des articles de l'ancien groupe "eleves-et-parents" vers les nouveaux groupes "eleves" et "responsables" (06/04/10)
	$install->setRows("SELECT `id` FROM `".$table_prefix."sentry_groups` WHERE `name`='eleves-et-parents';",DB_NAME);
	if(count($install->rows)>0)
		{
		$old_id = $install->rows[0]["id"];
		$install->setRows("SELECT `id` FROM `".$table_prefix."sentry_groups` WHERE `name` IN ('eleves','responsables');",DB_NAME);
		if(count($install->rows)==2)
			{
			$new_id = array($install->rows[0]["id"],$install->rows[1]["id"]);
			$install->setRows("SELECT `meta_id`,`post_id`,`meta_value` FROM `".$table_prefix."postmeta` WHERE `meta_key`='sentry_groups';",DB_NAME);
			foreach($install->rows as $row)
				{
				$meta_id = $row["meta_id"];
				$post_id = $row["post_id"];
				$groupes = explode(",",$row["meta_value"]);
				if(!in_array($old_id,$groupes)) continue; //ne concerne pas le groupe "eleves-et-parents"
				if(!in_array($new_id[0],$groupes)) $groupes[] = $new_id[0];
				if(!in_array($new_id[1],$groupes)) $groupes[] = $new_id[1];
				$keys = array_keys($groupes,$old_id);
				foreach($keys as $key) unset($groupes[$key]);
				$groupes = implode(",",$groupes);
				$install->query("UPDATE `".$table_prefix."postmeta` SET `meta_value`='".$groupes."' WHERE `meta_id`='".$meta_id."';",DB_NAME);
				}
			$install->query("DELETE FROM `".$table_prefix."sentry_groups` WHERE `name`='eleves-et-parents';",DB_NAME);
			}
		}

	//correctif car l'ancienne version du plugin était fortement limitée...
	//problème persistant : un utilisateur n'est placé dans un groupe que lors de sa première connexion donc il pourra persister des utilisateurs déjà présents dans aucun groupe
	$install->setRows("SHOW CREATE TABLE `".$table_prefix."sentry_groups`;",DB_NAME);
	if(count($install->rows)>0 && isset($install->rows[0]['Create Table']) && preg_match("/varchar\(255\)/i",$install->rows[0]['Create Table']))
		{
		$install->afficher("correctif... ");
		$install->query("ALTER TABLE `".$table_prefix."sentry_groups` CHANGE `member_list` `member_list` TEXT CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL;",DB_NAME);
		$install->query("ALTER TABLE `".$table_prefix."sentry_groups` CHANGE `member_of` `member_of` TEXT CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL;",DB_NAME);
		}

	$install->afficher("OK\n");
	}
else $install->afficher("PROBLEME : table \"".$table_prefix."sentry_groups\" non créée !\n");
//fin plugin wp-sentry

//spécifique EnvOLE 1.5 et donc voué à disparaître
//comme EnvOLE 1.5 peut être activé indépendamment et donc après wordpress : vérification systématique
if(AJAX_PORTAIL)
	{
	$install->afficher("Configuration de Ajax-Portail... ");
	
	$install->setRows("SELECT `value` FROM `".PORTAL_PREFIX."ajaxp_settings` WHERE `param`='VERSION_".strtoupper(APPLI_MODULE)."' LIMIT 1;",PORTAL_NAME);
	
	if(count($install->rows)===0) //premier reconfigure suite à l'activation d'EnvOLE 1.5
		{
		//pas utilisé mais similaire à ce qui est fait pour les autres applis
		$install->query("INSERT INTO `".PORTAL_PREFIX."ajaxp_settings` (`param`, `affichage`, `value`, `writable`, `visible`, `categorie`) VALUES 
		('VERSION_WORDPRESS', 'Numéro de version Wordpress', ".$wp_db_version.", 0, 0, 'Version'),
		('VERSION_WORDPRESS_ACADEMIQUE', 'Numéro de version Wordpress académique', 0, 0, 0, 'Version');",PORTAL_NAME);

		//quelques menus (tous, admin et perdir)
		$install->query("INSERT INTO `".PORTAL_PREFIX."ajaxp_menu` (`title`, `type`, `param`, `boxheight`, `torder`, `closable`, `meta_id`, `cat`) VALUES 
		( 'Infos de l''&eacute;tablissement', 'htmlBox', '/envole/redirection.php?ressource=wordpress_infos', 500, 37, 0, 0, 'ZZAutres services'),
		( 'Gestion des infos', 'inBox', '/envole/redirection.php?ressource=wordpress_gestion|../envole/images/nuvola/64x64/apps/knewsletter.png', 0, 54, 0, 22, 'ZZAutres services'),
		( 'Gestion des infos', 'inBox', '/envole/redirection.php?ressource=wordpress_gestion|../envole/images/nuvola/64x64/apps/knewsletter.png', 0, 54, 0, 38, 'ZZAutres services');",PORTAL_NAME);

		//un portlet dans la page initiale de l'admin (mais portlet orphelin si page supprimée depuis...)
		$install->query("INSERT INTO `".PORTAL_PREFIX."ajaxp_boxes` ( `seq`, `tid`, `title`, `content`, `cid`, `type`, `closable`, `ref_id`) VALUES 
		( 211, 1, 'Gestion des infos', '<center><a href=\"#\" style=\"display:block;\" onclick=\"openURL(''Gestion des infos'',''/envole/redirection.php?ressource=wordpress_gestion'');\"  title=\"Gestion des infos\"><img border=0 src=\"../envole/images/nuvola/64x64/apps/knewsletter.png\"></a></center>', 0, 'inBox', 0, 0);",PORTAL_NAME);
		}

	$install->afficher("OK\n");
	}

?>
